;;; This is not finished, I've got some problems with XShmPutImage. I don't
;;; know, where the error is. Perhaps I will find it... (...some day, if I
;;; have some time beside my studies...) So the only demonstration will be to
;;; show some points using XPolyPoint.
;;;
;;; xxampl.s
;;;
;;; created: <Sun Aug 20 17:24:30 2000>
;;; last modified: <Fri Sep 22 20:35:25 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;
;;; Show how simple it is, to open a little X window...
;;; (I know, the X support in libASM is buggy, neither perfect, nor complete,
;;;  or whatever!)
;;;

%include "system.h"
%include "libASM.h"
%include "linux/structs.h"

;;; Entry point and some little setup
	StartPoint

;;; Open display
	XOpenDisplay
	mov [Disp],eax

;;; Give information
	mov ebx,[eax+dpystruc.fd]
	mov ecx,[eax+dpystruc.info]
	WritefSTDOUT '*Disp = %d, Disp.fd = %d, Disp.info = %d', lf, dword [Disp], ebx, ecx
;;; Create window
	mov [attributes+XSetWindowAttributes.background_pixel], dword 0x00ffffff
	mov [attributes+XSetWindowAttributes.backing_store],dword Always
	mov eax,[Disp]
	XCreateWindow eax, dword [eax+dpystruc.default_root], dword 0, dword 0, dword 150, dword 100, dword 0, dword [eax+dpystruc.default_depth], dword InputOutput, dword CopyFromParent, dword CWBackPixel|CWBackingStore, dword attributes
	mov [wid],eax

pushad
	mov eax,[Disp]
WritefSTDERR 'wid = %d, default_root = %d, default_visualID = %d', lf, dword [wid], dword [eax+dpystruc.default_root], dword [eax+dpystruc.default_visualID]
popad
;;; Set window name
	Strlen dword WinName
	XSetWMName dword [Disp], dword [wid], dword XA_STRING, dword 8, dword WinName, eax

;;; Get SHM version
	XShmQueryVersion dword [Disp], dword shmmajor, dword shmminor, dword 0
	WritefSTDOUT 'MIT-SHM: majorVersion = %a, minorVersion = %a', lf, dword [shmmajor], dword [shmminor]

;;; Create shared memory image structure
	mov eax,[Disp]
	XShmCreateImage eax, dword 0, dword [eax+dpystruc.default_visualtype], dword [eax+dpystruc.default_depth], dword ZPixmap, dword 0, dword shm, dword 150, dword 100
	cmp eax,-1
	jne shm_ok
	GetErrorStr dword [_errno]
	WritefSTDERR "Can't create shared image structure (%e).", lf, eax
	XCloseDisplay dword [Disp]
	sys_exit dword 1

shm_ok:
	mov [image],eax

;;; Create shared memory segment
	mov ecx,[eax+ximagestruc.height]
	inc ecx
	imul ecx,[eax+ximagestruc.bytes_per_line]
	shmget dword IPC_PRIVATE, ecx, dword (IPC_CREAT|0777)
	cmp eax,-1
	jne shm2_ok
	GetErrorStr dword [_errno]
	WritefSTDERR "Can't create shared memory segment (%e).", lf, eax
	XCloseDisplay dword [Disp]
	sys_exit dword 1

shm2_ok:
	mov [shm+XShmSegmentInfo.shmid],eax

;;; Attach shared memory segment
	shmat dword [shm+XShmSegmentInfo.shmid], dword 0, dword 0
	cmp eax,-1
	jne shm3_ok
	GetErrorStr dword [_errno]
	WritefSTDERR "Can't attach shared memory segment (%e).", lf, eax
	XCloseDisplay dword [Disp]
	sys_exit dword 1

shm3_ok:
	mov [shm+XShmSegmentInfo.shmaddr],eax
	mov ebx,[image]
	mov [ebx+ximagestruc.data],eax

	mov [shm+XShmSegmentInfo.readOnly],dword False

;;; Attach X server to shared memory segment
	XShmAttach dword [Disp], dword shm
	cmp eax,-1
	jne shm4_ok
	GetErrorStr dword [_errno]
	WritefSTDERR "Can't attach Xserver to shared memory segment (%e).", lf, eax
	XCloseDisplay dword [Disp]
	sys_exit dword 1

shm4_ok:

;;; Create GC

;;; DRAWABLE!
;;; 	mov eax,[Disp]
;;; 	XCreateGC eax, dword [eax+dpystruc.default_root], dword 0, dword gcvals
;;; 	XCreateGC dword [Disp], dword [wid], dword 0, dword gcvals
	mov [gcvals+XGCValues.background],dword 0x00ffffff
	XCreateGC dword [Disp], dword [wid], dword GCBackground, dword gcvals
	cmp eax,-1
	jne gc_ok
	GetErrorStr dword [_errno]
	WritefSTDERR "Can't create gc (%e).", lf, eax
	XCloseDisplay dword [Disp]
	sys_exit dword 1

gc_ok:
	mov [gc],eax

pushad
WritefSTDERR 'gid = %d', lf, dword [gc]
popad

;;; Map window
	XMapWindow dword [Disp], dword [wid]

;;; Sync (Wait for Error?)
	XSync dword [Disp], dword 0, dword 0

;;; Modify memory...
	mov ebx,[image]
	mov eax,[ebx+ximagestruc.data]
	mov [image_data_ptr],eax
	mov edi,eax

	mov [edi+1234],dword 0x12345678

;;; Write shared memory segment to window
;;; 	XShmPutImage dword [Disp], dword [wid], dword [gc], dword [image], dword 0, dword 0, dword 0, dword 0, dword 150, dword 100, dword xFalse
;;;	mov eax,[Disp]
;;;	XShmPutImage eax, dword [eax+dpystruc.default_root], dword [gc], dword [image], dword 0, dword 0, dword 0, dword 0, dword 150, dword 100, dword xFalse
;;; Lustig: Wenn Map vorher, dann Match:wid, wenn hinterher, dann Match:gid
;;; Scheint nicht an CreateGC zu liegen, da XPolyPoint funktioniert!
;;; ???????????????????????????????????????????????????????????????????????

	XPolyPoint dword [Disp], dword [wid], dword [gc], dword CoordModeOrigin, dword 4, dword pts

;;;
;;; tbc...
;;;


;;; wait for a key
	WaitKeypressed

;;; Unmap window
	XUnmapWindow dword [Disp], dword [wid]

;;; Close display
	XCloseDisplay dword [Disp]

;;; exit
	sys_exit




	section .data
WinName:	db 'xxampl - test the X',0
pts:	dd 10,10,20,20,30,30,40,40,0

	section .bss
Disp:		resd 1
shmmajor:	resd 1
shmminor:	resd 1
wid:		resd 1
gc:		resd 1
image:		resd 1
image_data_ptr:	resd 1

attributes:	resb XSetWindowAttributes_size
shm:		resb XShmSegmentInfo_size
gcvals:		resb XGCValues_size


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: