;;;
;;; libASM.h
;;;
;;; created: <Fri May  7 21:03:48 1999>
;;; last modified: <Thu Feb 24 22:33:40 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;
;;; This helps to include ALL the libASM includes.
;;;

;;;
;;; Note: Most of this macros change eax.
;;;

%ifndef _libASM_h_
%define _libASM_h_

;;; Misc functions
%include "misc.h"

;;; I/O functions
%include "io.h"

;;; Memory functions
%include "mem.h"

;;; String functions
%include "string.h"

;;; IPC functions
%include "ipc.h"

;;; SYS functions
%include "sys.h"

;;; ZIP functions
%include "zip.h"

;;; SOUND functions
%include "sound.h"

;;; X functions
%include "x.h"

;;; MATHS functions
%include "maths.h"

%endif	; _libASM_h_



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: