;;;
;;; types.h
;;;
;;; created: <Fri Jul  9 07:50:19 1999>
;;; last modified: <Fri Jul  9 08:03:17 1999>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;; 
;;; Taken from asmutils-0.03 by Konstantin Boldyshev <konst@voshod.com>
;;;

;;; This is to handle kernel strucs easier

%ifndef _types_h_
%define _types_h_

%define	CHAR		resb
%define	U_CHAR		resb
%define	BYTE		resb
%define	U_BYTE		resb
%define	SHORT		resw
%define	U_SHORT		resw
%define	INT		resd
%define	U_INT		resd
%define	LONG		resd
%define	U_LONG		resd

%define	_CHAR		db
%define	_U_CHAR		db
%define	_BYTE		db
%define	_U_BYTE		db
%define	_SHORT		dw
%define	_U_SHORT	dw
%define	_INT		dd
%define	_U_INT		dd
%define	_LONG		dd
%define	_U_LONG		dd

%endif	; _types_h_


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: