;;;
;;; GetChar.s
;;;
;;; created: <Sun Apr 18 21:51:54 1999>
;;; last modified: <Thu Apr 20 20:36:45 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Reads char from fd.
;;; In: GetChar fd (eax)
;;; Out: eax=Char(on success); eax=-1(on error)
;;;

%include "system.h"

global _GetChar

extern _errno

	section .text
	align 32
_GetChar:
	push ebp
	sub esp,4		; this is correct
	mov ebp,esp

	sys_read eax, ebp, dword 1
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
	add esp,byte 4
	pop ebp
	ret
.noerr:
	mov eax,[ebp]
	add esp,byte 4
	pop ebp
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: