;;;
;;; IOData.s
;;;
;;; created: <Sun Apr 23 21:09:44 2000>
;;; last modified: <Sun Apr 23 21:31:19 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Data used in Writef.s WriteFloat*.s WriteHex.s WriteInt.s
;;;

global _IOpercent,_IOminus,_IObackslash,_IOnul,_IObel,_IObs,_IOht,_IOlf,_IOvt
global _IOff,_IOcr,_IOCharTab,_IOe,_IOE,_IOpoint


_IOCharTab:	db "0123456789abcdef"
_IOpercent:	db '%'
_IOminus:	db '-'
_IObackslash:	db '\'
_IOnul:		db 0
_IObel:		db 7
_IObs:		db 8
_IOht:		db 9
_IOlf:		db 10
_IOvt:		db 11
_IOff:		db 12
_IOcr:		db 13
_IOe:		db 'e'
_IOE:		db 'E'
_IOpoint:	db '.'



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: