;;;
;;; Assert.s
;;;
;;; created: <Thu Apr 29 23:34:53 1999>
;;; last modified: <Tue Apr  4 16:59:59 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Test val, exit program and give message (if defined) if val=0
;;;  In: _Assert val, *valstring, *srcfile, line (val [eax+0], *valstring [eax+4], *srcfile [eax+8], line [eax+12])
;;;  Out: -
;;;

%include "system.h"
%include "io.h"

global _Assert
extern _argv

%define line eax+12
%define srcfile eax+8
%define valstring eax+4
%define val eax+0

	section .text
	align 32
_Assert:
	cmp [val],dword 0
	je .doit
	ret

.doit:
	;; Write prg name, and msg
	mov ebx,dword [_argv]
	WritefSTDERR '%e:%e:%a: _Assert: Assertion failed:%e', dword [ebx], dword [srcfile], dword [line], dword [valstring]
	;; See ya!
	sys_exit dword 1



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: