#!/bin/sh
#
# asm2mkh
#
# created: <Fri Jan 12 23:44:30 2001>
# last modified: <Thu Feb  8 22:23:09 2001>
#
# Christian Fowelin <christian@fowelin.de>
#

linux_src=/usr/src/linux

values=$(grep ';;;  calls' ../src/include/system.h | sed -e 's/;;;  calls //g' -e 's/ -> /:/g')
chg=0

for v in ${values}; do
# Not very strickt, but...
    if test -z "$(grep -A1 asmlinkage ${linux_src}/$(echo ${v}|cut -d: -f2) | grep $(echo ${v}|cut -d: -f1))"; then
	echo "Has different location: ${v}"
	chg=1
    fi
done

test "${chg}" = "0" && echo "No differences detected!"

# Local Variables:
#  mode:Shell-script
#  eval:(load-library "time-stamp")
#  eval:(make-local-variable 'write-file-hooks)
#  eval:(add-hook 'write-file-hooks 'time-stamp)
#  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
#  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
# End:
