﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VizBin
{
	/// <summary>
	/// Provides a simple way to associate a directional indicator 
	/// with a number. This can be used to associate keylisteners
	/// with a defined action.
	/// </summary>
	public enum DirectionalEnum
	{
		/// <summary>
		/// Stay where you are!
		/// </summary>
		CENTER = 0,
		/// <summary>
		/// The opposite of down 
		/// </summary>
		UP = 1,
		/// <summary>
		/// Down direction
		/// </summary>
		DOWN = 2,
		/// <summary>
		/// Opposite of Right
		/// </summary>
		LEFT = 3,
		/// <summary>
		/// Go EAST!
		/// </summary>
		RIGHT = 4,
	}
}
