#!/bin/sh
#
#  Configure compilation of libASM
#
#   Created: <Mon May 31 21:52:14 1999>
#   last modified: <Sun Sep 30 16:42:15 2001>
#
#   Christian Fowelin <christian@fowelin.de>
#

PROJECT="libASM"

SUBDIRS="."
# src src/include src/misc src/mem src/io src/string src/ipc src/sys \
#    src/zip src/sound src/x doc doc/xampl"

# Get LIB_VER
#LIB_VER="0.0.1"
. lib_ver.h

#Defaults:
PREFIX=/usr

# ld jump in
LD_JUMPIN="-e __entry"

# ASM-Flags
ASM_FLAGS="-d___libASM___ -w+orphan-labels -w+macro-params"

#strip flags
STRIP_FLAGS="--remove-section .note --remove-section .comment"

# Local Variables:
#  mode:Shell-script
#  eval:(load-library "time-stamp")
#  eval:(make-local-variable 'write-file-hooks)
#  eval:(add-hook 'write-file-hooks 'time-stamp)
#  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
#  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
# End:
