;;;
;;; WriteInt.s
;;;
;;; created: <02.08.1998>
;;; last modified: <Sun Apr 23 21:24:58 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Convert reg to ASCII int and write it to fd
;;; In: WriteInt fd, reg (fd [eax+0], reg [eax+4])
;;; Out: -
;;;

%include "system.h"

global _WriteInt
extern _IOCharTab

%define reg ebx+4
%define fd ebx+0

	section .text
	align 32
_WriteInt:
	__push eax, ebx, ecx, edx, esi
	;; We don't check for errors here (until we change this...)
	mov ebx,eax
	mov eax,dword [reg]
	cmp eax,0
	jne .j1
	sys_write dword [fd], dword _IOCharTab+0, dword 1
	__pop esi, edx, ecx, ebx, eax
	ret

.j1:
	mov ebx,[fd]
	mov ecx,0
	mov esi,10

	align 32
.j2:
	cmp eax,0
	je .j3
	mov edx,0
	div esi
	push edx
	inc ecx
	jmp short .j2

.j3:
	mov edx,ecx
	align 32
.j4:
	pop ecx
 	add ecx,dword _IOCharTab
	sys_write ebx, ecx, dword 1
	dec edx
	jnz short .j4

	__pop esi, edx, ecx, ebx, eax
	ret

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: