;;;
;;; shmdt.s
;;;
;;; created: <Sun Jul  2 23:14:19 2000>
;;; last modified: <Sun Jul  2 23:17:59 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; In: shmdt *shmaddr (eax)
;;; Out: eax=0 (on success); eax=-1 (on error)
;;;

%include "system.h"

global _shmdt
extern _errno

	section .text
	align 32
_shmdt:
	sys_ipc dword SHMDT, dword 0, dword 0, dword 0, eax, dword 0
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: