;;;
;;; libINFO.s
;;;
;;; created: <22.02.1999>
;;; last modified: <Thu Jun  1 17:02:24 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

global libINFO_ver_high,libINFO_ver_low,libASM_ver_patchlevel
global libTEST

%include "libINFO.h"
%include "io.h"
%include "system.h"

	section .text
	align 32
libTEST:
	WritefSTDOUT  "This is %e %a.%a.%a compiled by %e.",lf, dword libINFO_project, dword [libINFO_ver_high], dword [libINFO_ver_low], dword [libINFO_ver_patchlevel], dword libINFO_makeby
	sys_exit dword 0

	section .data
	align 32
libINFO_ver_high:	dd VER_HIGH
libINFO_ver_low:	dd VER_LOW
libINFO_ver_patchlevel:	dd VER_PATCHLEVEL
libINFO_makeby:		db COMP,0
libINFO_project:	db PROJECT,0

;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: