;;;
;;; Strlen.s
;;;
;;; created: <Fri Oct  8 00:33:53 1999>
;;; last modified: <Tue Apr  4 10:23:40 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;;
;;; Return length of ASCIIZ string in src (NOT including '\0')
;;; In: Strlen src (eax)
;;; Out: eax=length
;;;

%include "system.h"

global _Strlen

	section .text
	align 32
_Strlen:
	__push ecx, edi

	mov edi,eax
	mov ecx,0xffffffff
	mov al,0
	cld
	repne scasb
	mov eax,0xfffffffe
	sub eax,ecx

	__pop edi, ecx
	ret



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: