;;;
;;; Bind.s
;;;
;;; created: <Fri Nov 12 22:26:49 1999>
;;; last modified: <Sun Jul  2 17:58:29 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;; In: Bind fd, *umyaddr, addrlen (fd [eax+0], *umyaddr [eax+4], addrlen [eax+8])
;;; Out: eax=0 (on success); eax=-1 (on error)


%include "system.h"

global _Bind
extern _errno

	section .text
	align 32
_Bind:
	sys_socketcall dword SYS_BIND, eax
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret



;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: