;;;
;;; Recv.s
;;;
;;; created: <Tue Dec 28 18:42:06 1999>
;;; last modified: <Tue May  2 00:09:06 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;; In: Recv fd, *buf, len, flags (fd [eax+0], *buf [eax+4], len [eax+8], flags [eax+12])
;;; Out: eax=0 (on success); eax=-1 (on error)

%include "system.h"

global _Recv
extern _errno

	section .text
	align 32
_Recv:
	sys_socketcall dword SYS_RECV, eax
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: