;;;
;;; Socket.s
;;;
;;; created: <Fri Nov 12 22:04:55 1999>
;;; last modified: <Tue May  2 00:09:38 2000>
;;;
;;; Christian Fowelin <christian@fowelin.de>
;;;
;;; Released under the LGPL (file COPYING).
;;;

;;; In: Socket family, type, protokoll (family [eax+0], type [eax+4], protokoll [eax+8])
;;; Out: eax=Socket descriptor (on success); eax=-1 (on error)


%include "system.h"

global _Socket
extern _errno

	section .text
	align 32
_Socket:
	sys_socketcall dword SYS_SOCKET, eax
	cmp eax,0
	jnl .noerr
	mov [_errno],eax
	mov eax,-1
.noerr:
	ret


;;; Local Variables:
;;;  mode:asm
;;;  eval:(load-library "time-stamp")
;;;  eval:(make-local-variable 'write-file-hooks)
;;;  eval:(add-hook 'write-file-hooks 'time-stamp)
;;;  eval:(setq time-stamp-start "last modified:[ 	]+\\\\?[\"<]+")
;;;  eval:(setq time-stamp-format "%3a %3b %2d %02H:%02M:%02S %y")
;;; End: