﻿using System;
using System.Runtime.InteropServices;

namespace VizBin
{
	/// <summary>
	/// Defines an enum to make determining which buttons are clicked
	/// and which direction they represent (N,S,E,W)
	/// </summary>
    public enum DirectionEnum
    {
        /// <summary>
        /// Default location.
        /// </summary>
        CENTER = 0,
        /// <summary>
        /// Left directional pressed
        /// </summary>
        LEFT = 1,
        /// <summary>
        /// Right directional pressed
        /// </summary>
        RIGHT = 2,
        /// <summary>
        /// Up directional pressed
        /// </summary>
        UP = 3,
        /// <summary>
        /// Down directional pressed
        /// </summary>
        DOWN = 4,
    }
}
